﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GrapeCity.ActiveReports.Samples.EndUserDesigner
{
    public class ReportTemplate
    {
        public int ID
        { get; set; }

        public string Type
        { get; set; }

        public string Name
        { get; set; }

        public string Icon
        { get; set; }

        public string Path
        { get; set; }

        public List<ReportTemplate> GetAll()
        {
            List<ReportTemplate> list = new List<ReportTemplate>();
            System.Xml.Linq.XElement doc = System.Xml.Linq.XElement.Load(@"Templates\TemplateList.xml");

            list = (from e in doc.Elements("Template")
                    select new ReportTemplate() { ID = int.Parse(e.Attribute("id").Value), Type = e.Attribute("type").Value, Name = e.Element("Name").Value, Icon = e.Element("Icon").Value, Path = e.Element("Path").Value }).ToList<ReportTemplate>();

            return list;
        }
    }
}
