﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GrapeCity.ActiveReports.Samples.EndUserDesigner
{
    public partial class Templates : Form
    {
        public Templates()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 返回选中的模板
        /// </summary>
        public ReportTemplate SelectedTemplate = new ReportTemplate();

        // 返回选中的模板
        private void btnOk_Click(object sender, EventArgs e)
        {
            if (tabControl1.SelectedIndex == 0)
            {
                SelectedTemplate = lvSection.SelectedItems[0].Tag as ReportTemplate;
                this.DialogResult = System.Windows.Forms.DialogResult.OK;
            }
            else
            {
                SelectedTemplate = lvPage.SelectedItems[0].Tag as ReportTemplate;
                this.DialogResult = System.Windows.Forms.DialogResult.OK;
            }
        }
        
        // 取消添加操作
        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = System.Windows.Forms.DialogResult.Cancel;
        }

        // 返回选中的模板
        private void lvSection_DoubleClick(object sender, EventArgs e)
        {
            SelectedTemplate = (sender as ListView).SelectedItems[0].Tag as ReportTemplate;
            this.DialogResult = System.Windows.Forms.DialogResult.OK;
        }
        // 返回选中的模板
        private void lvPage_DoubleClick(object sender, EventArgs e)
        {
            SelectedTemplate = (sender as ListView).SelectedItems[0].Tag as ReportTemplate;
            this.DialogResult = System.Windows.Forms.DialogResult.OK;
        }

        private void Templates_Load(object sender, EventArgs e)
        {
            // 加载自定义的模板
            LoadTemplate();
        }

        // 加载自定义的模板
        private void LoadTemplate()
        {            
            ReportTemplate template = new ReportTemplate();
            List<ReportTemplate> list = template.GetAll();

            foreach (ReportTemplate item in list)
            {
                if (item.Type == "Section")
                {
                    ListViewItem lvi = new ListViewItem(item.Name);
                    lvi.ImageKey = item.Icon;
                    lvi.Tag = item;
                    lvSection.Items.Add(lvi);
                }
                else
                {
                    ListViewItem lvi = new ListViewItem(item.Name);
                    lvi.ImageKey = item.Icon;
                    lvi.Tag = item;
                    lvPage.Items.Add(lvi);
                }
            }
        }
    }
}
